#Installs Packages
install.packages("bnlearn")
source("http://bioconductor.org/biocLite.R")
biocLite(c("graph", "Rgraphviz"))

#Loads Library
library(bnlearn)

#Importing and Prepping
data = read.csv(file = "C:/Users/berna/OneDrive/Desktop/Fall 2019 Project/Bayesian Network Data/CCGrade100GenesAstrocytoma.csv", header = TRUE, sep=",")
bn_df = data.frame(data)
bn_df[1:101] = lapply(bn_df[1:101], as.factor)

#Running
start_time_mmhc = Sys.time() 
mmhc = mmhc(bn_df)
end_time_mmhc = Sys.time()

start_time_gs = Sys.time() 
gs = gs(bn_df)
gs2 = gs
end_time_gs = Sys.time()

start_time_hc = Sys.time() 
hc = hc(bn_df)
end_time_hc = Sys.time()

#Network Information
mmhc
gs
hc

#Visualizing
arcs(mmhc)
graphviz.plot(mmhc)

arcs(gs)
#Setting Arc Direction
gs = set.arc(gs,"HCP5", "LMOD1")
gs = set.arc(gs,"GMPPA", "CDKL1")
gs = set.arc(gs,"RAC2", "MECOM")
gs = set.arc(gs,"MAPK8IP2", "FZD2")
gs = set.arc(gs,"HCLS1", "CUTC")
gs = set.arc(gs,"ANKRD11", "LTF")
gs = set.arc(gs,"AGBL3", "PKN1")
gs = set.arc(gs,"BICC1", "CENPF")

#Reversing Arc Direction
gs2 = set.arc(gs, "LMOD1","HCP5")
gs2 = set.arc(gs, "CDKL1","GMPPA")
gs2 = set.arc(gs, "MECOM","RAC2")
gs2 = set.arc(gs, "FZD2","MAPK8IP2")
gs2 = set.arc(gs, "CUTC","HCLS1")
gs2 = set.arc(gs, "LTF","ANKRD11")
gs2 = set.arc(gs, "PKN1","AGBL3")
gs2 = set.arc(gs, "CENPF","BICC1")
graphviz.plot(gs)

arcs(hc)
graphviz.plot(hc)
output = arcs(hc)
write.csv(output, file="C:/Users/berna/OneDrive/Desktop/hcarcs.csv")

#Scoring the networks
score(mmhc, bn_df)
score(gs, bn_df)
score(gs2, bn_df)
score(hc, bn_df)

#Cross Validation
#Perform cv 5 times
start_time_1 = Sys.time() 
bn.cv(bn_df, bn = "mmhc", k = 10)
end_time_1 = Sys.time()

start_time_2 = Sys.time() 
bn.cv(bn_df, bn = "gs", k = 10)
end_time_2 = Sys.time()

start_time_3 = Sys.time() 
bn.cv(bn_df, bn = "hc", k = 10)
end_time_3 = Sys.time()
warnings()
