#Installs Packages
install.packages("bnlearn")
source("http://bioconductor.org/biocLite.R")
biocLite(c("graph", "Rgraphviz"))

#Loads Library
library(bnlearn)

#Importing and Prepping
data = read.csv(file = "C:/Users/berna/OneDrive/Desktop/Fall 2019 Project/Bayesian Network Data/CCGrade100GenesGlioblastoma.csv", header = TRUE, sep=",")
bn_df = data.frame(data)
bn_df[1:101] = lapply(bn_df[1:101], as.factor)

#Running
start_time_mmhc = Sys.time() 
mmhc = mmhc(bn_df)
end_time_mmhc = Sys.time()

start_time_gs = Sys.time() 
gs = gs(bn_df)
gs2 = gs
end_time_gs = Sys.time()

start_time_hc = Sys.time() 
hc = hc(bn_df)
end_time_hc = Sys.time()

#Network Information
mmhc
gs
hc

#Visualizing
arcs(mmhc)
graphviz.plot(mmhc)

arcs(gs)
#Setting Arc Direction
gs = set.arc(gs,"RAVER2", "YAF2")
gs = set.arc(gs,"TRPC3", "TEX261")
gs = set.arc(gs,"CYP4F8", "ZNF257")
gs = set.arc(gs,"ABCD2", "SH3TC2")
gs = set.arc(gs,"MATN3", "MRPS14")
gs = set.arc(gs,"TLL1", "MYO1D")
gs = set.arc(gs,"MSX2", "MMP10")
gs = set.arc(gs,"ZNF442", "ADRA1B")
gs = set.arc(gs,"ZNF165", "IL7")

#Reversing Arc Direction
gs2 = set.arc(gs, "YAF2","RAVER2")
gs2 = set.arc(gs, "TEX261","TRPC3")
gs2 = set.arc(gs, "ZNF257","CYP4F8")
gs2 = set.arc(gs, "SH3TC2","ABCD2")
gs2 = set.arc(gs, "MRPS14","MATN3")
gs2 = set.arc(gs, "MYO1D","TLL1")
gs2 = set.arc(gs, "MMP10","MSX2")
gs2 = set.arc(gs, "ADRA1B","ZNF442")
gs2 = set.arc(gs, "IL7","ZNF165")
graphviz.plot(gs)

arcs(hc)
graphviz.plot(hc)
output = arcs(hc)
write.csv(output, file="C:/Users/berna/OneDrive/Desktop/hcarcs.csv")

#Scoring the networks
score(mmhc, bn_df)
score(gs, bn_df)
score(gs2, bn_df)
score(hc, bn_df)

#Cross Validation
#Perform cv 5 times
start_time_1 = Sys.time() 
bn.cv(bn_df, bn = "mmhc", k = 10)
end_time_1 = Sys.time()

start_time_2 = Sys.time() 
bn.cv(bn_df, bn = "gs", k = 10)
end_time_2 = Sys.time()

start_time_3 = Sys.time() 
bn.cv(bn_df, bn = "hc", k = 10)
end_time_3 = Sys.time()
warnings()
